3.2  Cлужебные программы JETHA

3.2.1  Описание had

Предназначение
==============

HAD - High Aviability Daemon - программа, осуществляющая работу кластера. 

Программа запускается на всех узлах кластера и выполняет следующие функции:
	* оповещение остальных узлов кластера о состоянии узла
	* переодическую проверку состояния узла 
	* перевод узла в активное/неактивное состояние

Для связи с другими узлами кластера используются специальные сетевые 
интерфейсы, именуюмые далее heartbeat интерфейсами. Программа может 
использовать от одного до трех heartbeat интерфейсов. Для функционирования
кластера необходимо функционирование хотя бы одного heartbeat интерфейса.

Состояния узла
==============

Программа HAD отслеживает следующие состояния узла:
	* RUNNING - обозначает активный узел (всегда один в кластере)
	* STANDBY - корректно функционирующий неактивный узел
	* ERRORED - некорректно функционирующий узел. После перехода в это
	  состояние узел прекращает все проверки и находится в нем до
	  перезапуска программы had
	* MAINTENANCE - активный узел, проверки функциональности которого 
	  выключены администратором. Используется в процессе настройки
	  прикладного ПО, работающего на узле
	* INITIAL - временное состояние, означающее что программа HAD находится
	  в процессе запуска
	* STOPPING - временное состояние, означающее процесс перевода узла в 
	  неактивное состояние
	* STARTING - временное состояние, означающее процесс перевода узла в 
	  активное состояние
	* TIMEDOUT - узел, связь с которым потеряна и состояние его не известно

Порядок запуска и остановки
===========================

В штатном режиме функционирования запуск осуществляется скриптом /etc/init.d/had. Скрипт
осуществляет чтение конфигурационного файла кластера и передачу соответствующих
параметров программе had.

Ключи командной строки
=======================
Синтаксис запуска программы had:

-a <IP>		задает IP адрес первого heartbeat интерфейса
-b <IP>		задает IP адрес второго heartbeat интерфейса (при его наличии)
-c <IP>		задает IP адрес третьего heartbeat интерфейса (при его наличии)

-A <IP>		задает broadcast адрес первого heartbeat интерфейса
-B <IP>		задает broadcast адрес второго heartbeat интерфейса (при его
		наличии)
-C <IP>		задает broadcast адрес третьего heartbeat интерфейса (при его
		наличии)
-l <путь>	задает файл сохранения состояния кластера. 
		По умолчанию: /var/run/freeha
-n <число>	задает число узлов кластера. По умолчанию: 2
-p <порт>	задает UDP порт для связи с узлами по heartbeat интерфейсу.
		Порт должен быть одинаковым на всех узлах. По умолчанию: 0xfee
-s <путь>	задает путь к каталогу с кластерными скриптами (см. далее)
-M <число>	задает переод мониторинга состояния кластера в секундах.
		По умолчанию: 1
-T <число>	определяет число секунд недоступности узла, по прошествии
		которых узел считается недоступным (TIMEDOUT).
		По умолчанию: 121
-m 		задает принудительный перевод узла кластера в активное
		состояние после запуска had

Сигналы
=======
Программа had специальным образом обрабатывает следующие сигналы:

SIGTERM		осуществляет корректное завершение работы узла. На активном
		узле посылка SIGTERM приводит к переводу узла в неактивное
		состояние и последующей остановке had

SIGINT		переключает режим MAINTENANCE кластера

SIGHUP		переводит узел кластера в неактивное состояние. Применяется
		только для активного узла

SIGUSR1		сбрасывает флаг ошибки и осуществляет принудительный
		запуск кластера

SIGUSR2		сбрасывает флаг ошибки и переводит кластер в состояние STANDBY

3.2.2  Описание monitorhasrv

Предназначение
==============

Программа monitorhasrv предназначена для проверки работоспособности кластера. 
Эта программа периодически вызывается резидентным процессом had и производит 
проверку корректности функционирования узла. В противном случае программа завершается с
с кодом возврата, равным 1. Если программа monitorhasrv завершается с с кодом возврата,
 равным 1, had переводит узел в состояние ERRORED


3.2.3 Описание starthasrv

Предназначение
==============

Программа starthasrv предназначается для запуска кластеризуемых служб или системных
ресурсов. Данный скрипт выполняется на узле, который был выбран основным и переводится
в состояние RUNNING.

3.2.4 Описание stophasrv

Предназначение
==============

Программа stophasrv предназначается для останова кластеризуемых служб или системных
ресурсов. Скрипт stophasrv запускается  резидентным процессом had в том случае, если узел кластера
переводится из состояния RUNNING в состояние ERRORED, то есть при обнаружении какой-либо ошибки 
одним из скриптов мониторинга.
